% obdelnik
%signal=obdelnik(DCL<0..1>,pocet_harmonickych)



function sumaa=obdelnik(strida,n)

close all

f1=1;
fvz=100;
D=3;

T1=1/f1;
v=strida*T1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

t=[0:1/fvz:4*T1];
osaf=linspace(0,fvz,length(t));

for k=1:n+1
	C(k)=(2*D*v/T1)*sinc((k-1)*v/T1); 
	if abs(C(k))<1e-12 
		C(k)=0;
	end
end

suma=C(1)/2;

if n>1	
  for k=2:n 
	suma=suma+C(k)*cos(2*pi*(k-1)*f1*t);
	
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%  kresba v asov oblasti
if n<11
	p=n;
else
	p=10;
end



figure(1)
subwindow(1,2);
	title('Casova oblast signalu')
	xlabel('t [s]'); ylabel('u(t) [V]')
	hold on
	for k=2:p
		plot(t,abs(C(k))*cos(2*pi*(k-1)*f1*t+arg(C(k))),'-');
	end
	grid on
	hold off

subwindow(1,2);
	xlabel('t [s]'); ylabel('u(t) [V]')
	hold on
	plot(t,suma);
	grid on; 
	hold off


	
%clf


%%%%%%%%%%%%%%%%%%   kresba ve frekvenn oblasti

sumaa=suma(1:length(suma)-1);
S=fft(sumaa);

delka=fix(length(t)/2)

amplituda=abs(S(1:delka));
argument=arg(S(1:delka));
for i=1:delka
	r=mod(i-1,4);
	if (r!=0) 
		argument(i)=0;
	else
		if amplituda(i)<0.1
			argument(i)=0;
		end
	end
end


figure(2)
subwindow(1,2)
	title('Amplitudove frekvencni spektrum');
	xlabel('f [Hz]'); ylabel('|U| [V]');
	stem(osaf(1:delka),amplituda);
	grid on

subwindow(1,2)
	title('Fazove frekvencni spektrum')
	xlabel('f [Hz]'); ylabel('arg(U) [rad]');
	stem(osaf(1:delka),argument);
	%plot(t,suma,"-");
	grid on;
%clf

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%oneplot;
%figure(3)
%	gset term postscript;
%	gset output="tist.eps";
%	hold on
%	for k=2:p
%%%%%		plot(t,abs(C(k))*cos(2*pi*(k-1)*f1*t+arg(C(k))),'-');
%	end
%	hold off
%	
%	plot(t,suma,'-');
%	stem(osaf(1:delka),amplituda,'o');
%	stem(osaf(1:delka),argument,'o');
%	
%	grid on
%clf
%
%oneplot;

%figure(4)
%	gset term postscript;
%	gset output "suma.ps";
%	hold on
%	plot(t,suma,'-');
%	grid on; 
%	hold off
%clf

%figure(5)
%	gset term postscript;
%	gset output "spektrum1.ps";
%	stem(osaf(1:delka),amplituda,'o');
	%plot(t,suma,"-");
%	grid on;
%	title('Fazove frekvencni spektrum')
%	xlabel('f [Hz]'); ylabel('arg(Ck) [rad]');
%clf

%figure(6)
	%gset term postscript;
	%gset output "spektrum2.ps";
	%stem(osaf(1:delka),argument,'o');
	%plot(t,suma,"-");
%	grid on;
%	title('Fazove frekvencni spektrum')
%	xlabel('f [Hz]'); ylabel('arg(Ck) [rad]');
%clf


